//---------------------------------------------------------------------------

#ifndef ApiTesterH
#define ApiTesterH
//---------------------------------------------------------------------------
#include<string.h>
#include "ApiProxyWrapper.h"
#include "ApiProxyWrapperReply.h"
class ApiTester :  public ApiProxyWrapperReply
{
public:
	ApiTester(void);
	~ApiTester(void);

	void Init();
    void Unload();

	void GetAccNo(char *acc);
	void GetUserId(char *user);
	void HelpInfo();
	int Login();
    void Logout();

	void AddOrder();						
	void SendMMOrder();                    
	void DeleteOrder();	
	void DeleteAllOrders();
	void ChangeOrder(); 
	void ChangeOrderBy();
	void GetActiveOrders();				      
	void SetOrderInactive();                 
	void GetOrderCount();  

	void PosCount();
	void GetPosByProduct();
    void GetAllPos();
    void GetAllPosByArray();
    void GetPos();

	void TradeCount();
	void GetAllTrade();

	void SubscribeUninitPrice(int idx);
	void GetPriceByCode();
	void SubscribeTicker();
	void UninitTicker();
	void SubscribeQuoteRequest();
	void SubscribeAllQuoteRequest();

	void GetAccInfo();
	void GetAccBalCount();
	void GetAllAccBal();
	void GetAccBalByCurrency();
	void GetConnectionStatus();
	void GetCcyRateByCcy();

	void ChangePassword();
	void SetApiLogPath();
	void AccountLogin();
	void AccountLogout();
    
    void LoadProductInfoListByCode();
    void GetProductCount();
    void GetProduct();									
    void GetProductByCode();									   

    void LoadInstrumentList();	
    void GetInstrumentCount();						
    void GetInstrument();								
    void GetInstrumentByCode();
    void SendAccControl();							


	virtual void OnTest();
	virtual void OnLoginReply(char *user_id, long ret_code,char *ret_msg);
	virtual void OnConnectedReply(long host_type, long con_status);
	virtual void OnApiOrderRequestFailed(tinyint action, const SPApiOrder *order, long err_code, char *err_msg);
	virtual void OnApiOrderReport(long rec_no, const SPApiOrder *order);
	virtual void OnApiOrderBeforeSendReport(const SPApiOrder *order);
	virtual void OnAccountLoginReply(char *accNo, long ret_code, char* ret_msg);
	virtual void OnAccountLogoutReply(char *accNo, long ret_code, char* ret_msg);
	virtual void OnAccountInfoPush(const SPApiAccInfo *acc_info);
	virtual void OnAccountPositionPush(const SPApiPos *pos);
	virtual void OnUpdatedAccountPositionPush(const SPApiPos *pos);
	virtual void OnUpdatedAccountBalancePush(const SPApiAccBal *acc_bal);
	virtual void OnApiTradeReport(long rec_no, const SPApiTrade *trade);
	virtual void OnApiPriceUpdate(const SPApiPrice *price);
	virtual void OnApiTickerUpdate(const SPApiTicker *ticker);
	virtual void OnPswChangeReply(long ret_code, char *ret_msg);
	virtual void OnProductListByCodeReply(char *inst_code, bool is_ready, char *ret_msg);
	virtual void OnInstrumentListReply(bool is_ready, char *ret_msg);
	virtual void OnBusinessDateReply(long business_date);
	virtual void OnApiMMOrderBeforeSendReport(SPApiMMOrder *mm_order);
	virtual void OnApiMMOrderRequestFailed(SPApiMMOrder *mm_order, long err_code, char *err_msg);
	virtual void OnApiQuoteRequestReceived(char *product_code, char buy_sell, long qty);
    virtual void OnApiAccountControlReply(long ret_code, char *ret_msg);
    virtual void OnApiLoadTradeReadyPush(long rec_no, const SPApiTrade *trade);
private:
	ApiProxyWrapper apiProxyWrapper;
};

#endif
